// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_NOTE_H
#define _HILDONMM_NOTE_H


#include <glibmm.h>

/*
 * Copyright (c) 2005-2009  The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtkmm/dialog.h>
#include <gtkmm/progressbar.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonNote HildonNote;
typedef struct _HildonNoteClass HildonNoteClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class Note_Class; } // namespace Hildon
namespace Hildon
{

/** @addtogroup hildonmmEnums Enums and Flags */

/**
 * @ingroup hildonmmEnums
 */
enum NoteType
{
  NOTE_TYPE_CONFIRMATION,
  NOTE_TYPE_CONFIRMATION_BUTTON,
  NOTE_TYPE_INFORMATION,
  NOTE_TYPE_INFORMATION_THEME,
  NOTE_TYPE_PROGRESSBAR
};

} // namespace Hildon


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Hildon::NoteType> : public Glib::Value_Enum<Hildon::NoteType>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{


/** @defgroup HildonDialogs Dialogs
 */

/** A dialog to ask the user for confirmation.
 *
 * Hildon::Note is a convenient way to prompt users for a small amount of
 * input. A simple note contains an information text and, in case of
 * confirmation notes, it shows buttons to confirm or cancel. It also can
 * include a progress bar.
 *
 * This widget provides convenient constructors to create either information
 * notes, confirmation notes or cancel notes, which are useful to show the
 * progress of a requested task allowing the user to cancel it.
 *
 * To create information notes you can use Hildon::Note::Note(NoteType, const
 * Glib::ustring&) with Hildon::NOTE_TYPE_INFORMATION, which creates a note
 * with a text and two buttons to confirm or cancel. Note that it is possible
 * to create a confirmation note with customized buttons by using
 * Gtk::Dialog::add_button().
 *
 * To create a note with a text, a progress bar and a cancel button, the
 * Hildon::Note::Note(Gtk::ProgressBar&, const Glib::ustring&) constructor can
 * be used.
 *
 * @ingroup HildonDialogs
 */

class Note : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Note CppObjectType;
  typedef Note_Class CppClassType;
  typedef HildonNote BaseObjectType;
  typedef HildonNoteClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Note();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Note_Class;
  static CppClassType note_class_;

  // noncopyable
  Note(const Note&);
  Note& operator=(const Note&);

protected:
  explicit Note(const Glib::ConstructParams& construct_params);
  explicit Note(HildonNote* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonNote*       gobj()       { return reinterpret_cast<HildonNote*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonNote* gobj() const { return reinterpret_cast<HildonNote*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:
  explicit Note(NoteType note_type, const Glib::ustring& description = Glib::ustring());
  explicit Note(Gtk::ProgressBar& progressbar, const Glib::ustring& description = Glib::ustring());
  Note(NoteType note_type, Gtk::Window& parent, const Glib::ustring& description = Glib::ustring());
  Note(Gtk::ProgressBar& progressbar, Gtk::Window& parent, const Glib::ustring& description = Glib::ustring());

  
  /** Sets the text of the button in @a note.
   * @param text Sets the button text. If there are two buttons in dialog,
   * the button texts will be <text>, "Cancel".
   */
  void set_button_text(const Glib::ustring& text);
  
  /** Sets the text for the buttons in @a note.
   * @param text_ok The new text of the default OK button.
   * @param text_cancel The new text of the default cancel button.
   */
  void set_button_text(const Glib::ustring& text_ok, const Glib::ustring& text_cancel);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The type of the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<NoteType> property_note_type() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The type of the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<NoteType> property_note_type() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The text that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_description() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The text that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_description() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The progressbar that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::ProgressBar*> property_progressbar() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The progressbar that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::ProgressBar*> property_progressbar() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Hildon


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Hildon::Note
   */
  Hildon::Note* wrap(HildonNote* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_NOTE_H */

