// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_TIME_SELECTOR_H
#define _HILDONMM_TIME_SELECTOR_H


#include <glibmm.h>

/*
 * Copyright (c) 2009  The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <hildonmm/touch-selector.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonTimeSelector HildonTimeSelector;
typedef struct _HildonTimeSelectorClass HildonTimeSelectorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class TimeSelector_Class; } // namespace Hildon
namespace Hildon
{

/** A widget to select the current time.
 *
 * This widget allows users to choose a time by selecting the hour and minute. It also allows the user to choose between AM or PM.
 * The currently selected time can be altered with set_time(), and retrieved using get_time().
 *
 * @ingroup HildonWidgets
 */

class TimeSelector : public TouchSelector
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TimeSelector CppObjectType;
  typedef TimeSelector_Class CppClassType;
  typedef HildonTimeSelector BaseObjectType;
  typedef HildonTimeSelectorClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~TimeSelector();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class TimeSelector_Class;
  static CppClassType timeselector_class_;

  // noncopyable
  TimeSelector(const TimeSelector&);
  TimeSelector& operator=(const TimeSelector&);

protected:
  explicit TimeSelector(const Glib::ConstructParams& construct_params);
  explicit TimeSelector(HildonTimeSelector* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonTimeSelector*       gobj()       { return reinterpret_cast<HildonTimeSelector*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonTimeSelector* gobj() const { return reinterpret_cast<HildonTimeSelector*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  TimeSelector();
  explicit TimeSelector(guint minutes_step);

  
  /** Sets the current active hour on the Hildon::TimeSelector widget
   * 
   * The format of the hours accepted is always 24h format, with a range
   * (0-23):(0-59).
   * 
   * @newin{2,2}
   * @param hours The current hour (0-23).
   * @param minutes The current minute (0-59).
   * @return <tt>true</tt> on success, <tt>false</tt> otherwise.
   */
  bool set_time(guint hours, guint minutes);
  
  /** Gets the current active hour on the Hildon::TimeSelector widget. Both @a year
   * and @a minutes can be <tt>0</tt>.
   * 
   * This method returns the date always in 24h format, with a range (0-23):(0-59)
   * 
   * @newin{2,2}
   * @param hours To set the current hour (0-23).
   * @param minutes To set the current minute (0-59).
   */
  void get_time(guint& hours, guint& minutes) const;

  guint get_hours() const;
  guint get_minutes() const;


};

} // namespace Hildon


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Hildon::TimeSelector
   */
  Hildon::TimeSelector* wrap(HildonTimeSelector* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_TIME_SELECTOR_H */

