// Generated by gtkmmproc -- DO NOT MODIFY!


#include <hildonmm/window-stack.h>
#include <hildonmm/private/window-stack_p.h>

/*
 * Copyright (c) 2009  The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <hildon/hildon.h>

namespace Hildon
{

bool WindowStack::empty() const
{
  return (hildon_window_stack_size(const_cast<HildonWindowStack*>(gobj())) == 0);
}

Glib::ListHandle<StackableWindow*> WindowStack::pop(int nwindows)
{
  GList* popped_windows = 0;
  hildon_window_stack_pop(gobj(), nwindows, &popped_windows);

  return Glib::ListHandle<StackableWindow*>(popped_windows, Glib::OWNERSHIP_SHALLOW);
}

Glib::ListHandle<StackableWindow*>
WindowStack::pop_and_push(int nwindows, const Glib::ListHandle<StackableWindow*>& list)
{
  GList* popped_windows = 0;
  hildon_window_stack_pop_and_push_list(gobj(), nwindows, &popped_windows, list.data());

  return Glib::ListHandle<StackableWindow*>(popped_windows, Glib::OWNERSHIP_SHALLOW);
}

} // namespace Hildon

namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Hildon::WindowStack> wrap(HildonWindowStack* object, bool take_copy)
{
  return Glib::RefPtr<Hildon::WindowStack>( dynamic_cast<Hildon::WindowStack*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Hildon
{


/* The *_Class implementation: */

const Glib::Class& WindowStack_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &WindowStack_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(hildon_window_stack_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void WindowStack_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* WindowStack_Class::wrap_new(GObject* object)
{
  return new WindowStack((HildonWindowStack*)object);
}


/* The implementation: */

HildonWindowStack* WindowStack::gobj_copy()
{
  reference();
  return gobj();
}

WindowStack::WindowStack(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

WindowStack::WindowStack(HildonWindowStack* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


WindowStack::~WindowStack()
{}


WindowStack::CppClassType WindowStack::windowstack_class_; // initialize static member

GType WindowStack::get_type()
{
  return windowstack_class_.init().get_type();
}


GType WindowStack::get_base_type()
{
  return hildon_window_stack_get_type();
}


WindowStack::WindowStack()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(windowstack_class_.init()))
{
  

}

Glib::RefPtr<WindowStack> WindowStack::create()
{
  return Glib::RefPtr<WindowStack>( new WindowStack() );
}
Glib::RefPtr<WindowStack> WindowStack::get_default()
{

  Glib::RefPtr<WindowStack> retvalue = Glib::wrap(hildon_window_stack_get_default());

  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}


int WindowStack::size() const
{
  return hildon_window_stack_size(const_cast<HildonWindowStack*>(gobj()));
}

StackableWindow* WindowStack::top() const
{
  return Glib::wrap(reinterpret_cast<HildonStackableWindow*>(hildon_window_stack_peek(const_cast<HildonWindowStack*>(gobj()))));
}

void WindowStack::push(StackableWindow* win)
{
hildon_window_stack_push_1(gobj(), Glib::unwrap(win)); 
}

StackableWindow* WindowStack::pop()
{
  return Glib::wrap(reinterpret_cast<HildonStackableWindow*>(hildon_window_stack_pop_1(gobj())));
}

void WindowStack::push(const Glib::ListHandle<StackableWindow*>& list)
{
hildon_window_stack_push_list(gobj(), (list).data()); 
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Hildon


